(function(){
  var app=angular.module('couponApp');
  app.controller('WeeklyDealsController',['$scope','$rootScope','GeneralServices','$state','$ionicLoading','$stateParams','FILE_BASE_URL','$ionicPlatform','GAnalyticsService','$cordovaSocialSharing',function($scope,$rootScope,GeneralServices,$state,$ionicLoading,$stateParams,FILE_BASE_URL,$ionicPlatform,GAnalyticsService,$cordovaSocialSharing){

    //$scope.city=$stateParams.city;

    $scope.storeduser=angular.fromJson(window.localStorage['user'] || '{}');
    $scope.city=$scope.storeduser.city;

    $scope.rechargedenominations=[
      {
        amount:10
      },
      {
        amount:50
      },
      {
        amount:100
      },
      {
        amount:150
      },
      {
        amount:200
      }
    ]

    $scope.shownGroup=0;

    $scope.recharge={
      amount:10,
      operator:'AT',
      rechargetype:0
    }
    $scope.initRecharger=function(){
      $scope.recharge.amount=10;
      $scope.recharge.rechargetype=0;
      $scope.recharge.operator='AT';
      try{
        branch.credits(function(err, data) {
          if (!err) {
            console.log('credits-'+angular.toJson(data));
            // will return the balance of the current user's credits
            $scope.credits = data.default;
            $rootScope.creditsAll=$scope.credits;
            $scope.$apply();
          }
        });
      }
      catch(err){
        console.log('err-'+err);
        $scope.credits=0;
        $rootScope.creditsAll=$scope.credits;
        $scope.$apply();
      }
      try{
        branch.link({
          channel: 'sms'
        }, function(err, link) {
            $scope.link=link;
            $scope.$apply();
        });
      }
      catch(err){
        $scope.$apply();
      }
      $scope.$broadcast('scroll.refreshComplete');
    }

    $scope.toggleGroup = function(group) {
      if ($scope.isGroupShown(group)) {
        $scope.shownGroup = null;
      } else {
        $scope.shownGroup = group;
      }
    };
    $scope.isGroupShown = function(group) {
      return $scope.shownGroup === group;
    };

    $scope.rechargeNow=function(){
      $ionicLoading.show({
        content: 'Loding coupons!',
        animation: 'fade-in',
        maxWidth: 200,
        showDelay: 0
      });
      try{
        if($scope.credits>=10){
          var resp=GeneralServices.rechargeMobile($scope.storeduser.id,$scope.recharge.mobile,$scope.recharge.operator,$scope.recharge.amount,$scope.recharge.rechargetype);
          resp.$promise.then(function(response){

            // {
            //   "response_data": {
            //       "Recharge": {
            //           "txnstatus": "FAILED",
            //           "errorcode": "22",
            //           "user_id": "55b78002-ad88-40a2-8b2f-525dc0b9584f"
            //       }
            //   }
            // }
            console.log('response-'+angular.toJson(response));
            var status=response.response_data.Recharge.txnstatus;

            if(status=='FAILED'){
              //Failure Status of transaction
              //Do not redeem
              alert('Something went wrong while recharge! Try again.');
            }
            else if(status=='PENDING'){
              //Pending Status of transaction
              //Redeem
              var amount=parseInt($scope.recharge.amount);
              branch.redeem(amount,"default",function(err){
                //console.log('err-'+err);
                  alert('Your recharge is pending on your operator.');
                  $scope.initRecharger();
              });
            }
            else if(status=='SUCCESS'){
              //Success Status of transaction
              //Redeem
              var amount=parseInt($scope.recharge.amount);
              branch.redeem(amount,"default",function(err){
                //console.log('err-'+err);
                  alert('Your recharge is done!');
                  $scope.initRecharger();
              });
            }
            else{
              alert('Something went wrong while recharge! Try again.');
            }

            $ionicLoading.hide();
          },
          function(err){
            alert('Something went wrong! Try again.');
            $ionicLoading.hide();
          });

        }
      }
      catch(err){
        console.log('err-'+err);
        alert('Something went wrong! Try again');
        $ionicLoading.hide();
      }
    }

    $scope.generateLink=function(){

    }

    $scope.inviteFriends=function(){
      try{
        $cordovaSocialSharing.share("Hey ! I Downloaded MyCITYBUZZ Mobile App in My Mobile and I am getting Daily Exclusive Discount Offers. Now you can download and Get Free Mobile Recharge and Daily Discount Offers also. Click to download - " + $scope.link, "Download MyCityBuzz App",null,"");
      }
      catch(err){

      }
    }

    // $scope.coupons=[];
    // $scope.coupons[0]={
    //   Organisation:{
    //     org_name:'Boss Taylors'
    //   },
    //   CouponCategory:{
    //     name: 'Lifestyle'
    //   },
    //   Offer:{
    //     title:'50% Off on apparells!'
    //   },
    //   imgurl:'http://mycitybuzz.in/admin/files/organisation/image_name/55bb8b14-5780-46e3-81ab-0e55c0b9584f/Logo.png',
    //   bigimg:'http://mycitybuzz.in/admin/files/photo/file_name/55bb8c1d-f0cc-403d-9ede-2877c0b9584f/Cake%20Studio_Pramotion_A.png'
    // }
    // $scope.coupons[1]={
    //   Organisation:{
    //     org_name:'Boss Taylors'
    //   },
    //   CouponCategory:{
    //     name: 'Lifestyle'
    //   },
    //   Offer:{
    //     title:'50% Off on apparells!'
    //   },
    //   imgurl:'http://mycitybuzz.in/admin/files/organisation/image_name/55bb8b14-5780-46e3-81ab-0e55c0b9584f/Logo.png',
    //   bigimg:'http://mycitybuzz.in/admin/files/photo/file_name/55bb8c1d-f0cc-403d-9ede-2877c0b9584f/Cake%20Studio_Pramotion_A.png'
    // }

    try{
      GAnalyticsService.view('InviteUsers');
    }
    catch(err){
      console.log(err);
    }

    // $scope.loadCoupons=function(hide_loading){
    //   if(!hide_loading){
    //     $ionicLoading.show({
    //       content: 'Loding coupons!',
    //       animation: 'fade-in',
    //       maxWidth: 200,
    //       showDelay: 0
    //     });
    //   }
    //
    //   console.log('city-'+$scope.city);
    //   var resp=CouponServices.getWeeklyCoupons($scope.city);
    //   resp.$promise.then(function(response){
    //     if(!hide_loading){
    //       $ionicLoading.hide();
    //     }
    //
    //     //console.log('couponid-'+$scope.coupons[0].Offer.code);
    //     //$state.go('verifyotp',{user:angular.toJson(response.response_data.AppUser)});
    //     for(var i=0;i<response.response_data.length;i++){
    //
    //       if(response.response_data[i].Photo.length!==0){
    //         response.response_data[i].bigimg=FILE_BASE_URL+'/photo/file_name/'+response.response_data[i].Photo[0].file_dir+'/'+response.response_data[i].Photo[0].file_name;
    //       }
    //       else{
    //         response.response_data[i].bigimg='img/logo-gray.jpg';
    //       }
    //
    //       if(response.response_data[i].Organisation.image_dir==null||response.response_data[i].Organisation.image_dir==''){
    //         response.response_data[i].imgurl='img/logo-gray.jpg';
    //       }
    //       else{
    //         response.response_data[i].imgurl=FILE_BASE_URL+'/organisation/image_name/'+response.response_data[i].Organisation.image_dir+'/'+response.response_data[i].Organisation.image_name;
    //       }
    //     }
    //
    //     $scope.coupons=response.response_data;
    //     $scope.$broadcast('scroll.refreshComplete');
    //
    //   },
    //   function(err){
    //     alert('Oops! Something went wrong! Try again.')
    //     if(!hide_loading){
    //       $ionicLoading.hide();
    //     }
    //     $scope.$broadcast('scroll.refreshComplete');
    //   });
    // }
    //
    // $scope.showCouponDetails=function(couponid){
    //   $state.go('app.coupondetail',{id:couponid,params:1});
    // }

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      $ionicPlatform.registerBackButtonAction(function () {
        navigator.app.exitApp();
      }, 600);
    });

    $scope.getDenominations=function(retype){
      if(retype==0){
        //Prepaid
        // $scope.rechargedenominations=[
        //   {
        //     amount:10
        //   },
        //   {
        //     amount:50
        //   },
        //   {
        //     amount:100
        //   },
        //   {
        //     amount:150
        //   },
        //   {
        //     amount:200
        //   }
        // ]
        $scope.recharge.amount=10;
        $scope.recharge.operator='AT';
      }
      else if(retype==1){
        //Postpaid
        // $scope.rechargedenominations=[
        //   {
        //     amount:100
        //   },
        //   {
        //     amount:150
        //   },
        //   {
        //     amount:200
        //   }
        // ]
        $scope.recharge.amount=100;
        $scope.recharge.operator='APOS';
      }
    }


  }]);
})();
